//
//  AliMITEffectModule.h
//
//  Created by 沐翊 on 17/5/12.
//  Copyright © 2017年 Taobao.com. All rights reserved.
//
#ifndef AliMITEffectModule_h
#define AliMITEffectModule_h

//注意：目前这个特效库只支持单例，不支持多实例！


#include  "AliMITBaseStructDefine.h"


#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif
#endif /* __cplusplus */

int GetContextInfo(void *pLibInitedEglContext, void *pSystemCurrentUsingEglContext);


//库的生命周期中，只在开始调用一次。必须在glcontext上下文中！
//init所有渲染相关的资源。参数是glcontext。
//todo: 1）context传递保护，抽离出来放在调度层做。
//      2）Android context 维护要梳理统一方案，以免context污染。
int InitEffectModule();


//库的生命周期中，只在最后调用一次。根据是否在glcontext中而设置参数。
int DeinitEffectModule();


//只在选择／改变效果的时候调用。必须在glcontext上下文中！
int AddEffect(AliEffectType effectType);
int RemoveEffect(AliEffectType effectType);


//动态设置美颜的参数（可每帧改变）。必须在glcontext上下文中！
int SetParamsForFaceBeauty(
        float fSkinSmooth, // [ it's skin smooth param( default: 0.65f; range: 0 ~ 1 ) ]
        float fWhiten, // [ it's whtien param( default: 0.1f; range: 0 ~ 1 ) ]
        float fWholeFacePink, // [ it's whole face pink param( default: 0.15f; range: 0 ~ 1 ) ]
        float fThinFace_Horizontal, // [ it's shape hor param( default: 0.35f; range: 0 ~ 1 ) ]
        float fCheekPink, // [ it's cheek pink param( default: 0.2f; range: 0 ~ 1 ) ]
        float fShortenFace_Vertical, // [ it's shape ver param( default: 0.0f; range: 0 ~ 1 ) ]
        float fBigEye // [ it's shape eye param( default: 0.5f; range: 0 ~ 1 ) ]
);

//动态设置动态贴纸的参数（可每帧改变）。必须在glcontext上下文中！
int UpdateUsrImgResInfoForChartletEffect(
        bool bIfUpdateResourceRawData, ImgRawData *pImgResourceRawData,
        bool bIfUpdateResourcPosition, ResourceVertexPosition *pResourceVertexPositionInPixel
);

//动态设置动态贴纸的参数（可每帧改变）。必须在glcontext上下文中！
int UpdateUsrImgResInfoForChartletEffects(
        bool bIfUpdateResourceRawData, ImgRawData *pImgResourceRawData[],
        bool bIfUpdateResourcPosition, ResourceVertexPosition *pResourceVertexPositionInPixel[],
        int conut
);


//以下是不同形式的OneFrameProcess_***_***In_***Out（针对不同输入输出case）。必须在glcontext上下文中！
//每种形式的OneFrameProcess_***_***In_***Out里面都是调用后面那个相对通用但是复杂的FrameProcess，只是为了对调用方屏蔽复杂的参数设置。
//当然，你也可以直接调后面那个相对通用但是复杂的FrameProcess（例如，如果你的调用case不在以下常见case之列，或者你更喜欢统一的感觉...)。
int OneFrameProcess_WithFaceInfo_OesTexIn_TexOut(
        GpuImgResourceInfo *pInputOesTexInfo,
        int *pFaceRect, float *pFaceLandmark,//直接把人脸算法的输出赋值到这里
        GpuImgResourceInfo *pOutputTexInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int OneFrameProcess_WithFaceInfo_UsrAllocTexIn_TexOut(
        GpuImgResourceInfo *pInputUsrAllocTexInfo,
        int *pFaceRect, float *pFaceLandmark,//直接把人脸算法的输出赋值到这里
        GpuImgResourceInfo *pOutputTexInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);


int OneFrameProcess_WithFaceInfo_RawIn_TexOut(
        ImgRawData *pInputRawData,
        int *pFaceRect, float *pFaceLandmark,//直接把人脸算法的输出赋值到这里
        GpuImgResourceInfo *pOutputTexInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);


int OneFrameProcess_WithFaceInfo_OesTexIn_FboOut(
        GpuImgResourceInfo *pInputOesTexInfo,
        int *pFaceRect, float *pFaceLandmark,//直接把人脸算法的输出赋值到这里
        GpuImgResourceInfo *pOutputFboInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int OneFrameProcess_WithFaceInfo_UsrAllocTexIn_FboOut(
        GpuImgResourceInfo *pInputUsrAllocTexInfo,
        int *pFaceRect, float *pFaceLandmark,//直接把人脸算法的输出赋值到这里
        GpuImgResourceInfo *pOutputFboInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);


int OneFrameProcess_WithFaceInfo_RawIn_FboOut(
        ImgRawData *pInputRawData,
        int *pFaceRect, float *pFaceLandmark,//直接把人脸算法的输出赋值到这里
        GpuImgResourceInfo *pOutputFboInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);


int OneFrameProcess_WithFaceInfo_OesTexIn_RawOut(
        GpuImgResourceInfo *pInputOesTexInfo,
        int *pFaceRect, float *pFaceLandmark,//直接把人脸算法的输出赋值到这里
        ImgRawData *pOutputBuffer,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int OneFrameProcess_WithFaceInfo_UsrAllocTexIn_RawOut(
        GpuImgResourceInfo *pInputUsrAllocTexInfo,
        int *pFaceRect, float *pFaceLandmark,//直接把人脸算法的输出赋值到这里
        ImgRawData *pOutputBuffer,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);


int OneFrameProcess_WithFaceInfo_RawIn_RawOut(
        ImgRawData *pInputRawData,
        int *pFaceRect, float *pFaceLandmark,//直接把人脸算法的输出赋值到这里
        ImgRawData *pOutputBuffer,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);


int OneFrameProcess_NoFaceRelated_OesTexIn_TexOut(
        GpuImgResourceInfo *pInputOesTexInfo,
        GpuImgResourceInfo *pOutputTexInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int OneFrameProcess_NoFaceRelated_UsrAllocTexIn_TexOut(
        GpuImgResourceInfo *pInputUsrAllocTexInfo,
        GpuImgResourceInfo *pOutputTexInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);


int OneFrameProcess_NoFaceRelated_RawIn_TexOut(
        ImgRawData *pInputRawData,
        GpuImgResourceInfo *pOutputTexInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int OneFrameProcess_NoFaceRelated_OesTexIn_FboOut(
        GpuImgResourceInfo *pInputOesTexInfo,
        GpuImgResourceInfo *pOutputFboInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int OneFrameProcess_NoFaceRelated_UsrAllocTexIn_FboOut(
        GpuImgResourceInfo *pInputUsrAllocTexInfo,
        GpuImgResourceInfo *pOutputFboInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int OneFrameProcess_NoFaceRelated_RawIn_FboOut(
        ImgRawData *pInputRawData,
        GpuImgResourceInfo *pOutputFboInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int OneFrameProcess_NoFaceRelated_OesTexIn_RawOut(
        GpuImgResourceInfo *pInputOesTexInfo,
        ImgRawData *pOutputBuffer,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int OneFrameProcess_NoFaceRelated_UsrAllocTexIn_RawOut(
        GpuImgResourceInfo *pInputUsrAllocTexInfo,
        ImgRawData *pOutputBuffer,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int OneFrameProcess_NoFaceRelated_RawIn_RawOut(
        ImgRawData *pInputRawData,
        ImgRawData *pOutputBuffer,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);


//以下是不同形式的TwoFramesMergeIntoOne_***_***In_***Out（针对不同输入输出case）。必须在glcontext上下文中！
//每种形式的TwoFramesMergeIntoOne_***_***In_***Out里面都是调用后面那个相对通用但是复杂的TwoFramesMergeIntoOne，只是为了对调用方屏蔽复杂的参数设置。
//当然，你也可以直接调后面那个相对通用但是复杂的TwoFramesMergeIntoOne（例如，如果你的调用case不在以下常见case之列，或者你更喜欢统一的感觉...)。
int TwoFramesMergeIntoOne_NoFaceRelated_RawIn_TexOut(
        ImgRawData *pInputRawData0,
        ImgRawData *pInputRawData1,
        GpuImgResourceInfo *pOutputTexInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);

int TwoFramesMergeIntoOne_NoFaceRelated_RawIn_FboOut(
        ImgRawData *pInputRawData0,
        ImgRawData *pInputRawData1,
        GpuImgResourceInfo *pOutputFboInfo,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);


int TwoFramesMergeIntoOne_NoFaceRelated_RawIn_RawOut(
        ImgRawData *pInputRawData0,
        ImgRawData *pInputRawData1,
        ImgRawData *pOutputRawData,
        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY
);


///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//在常用情境下，调用方都是不需要用下面这些参数比较多的通用接口的（除非同一句调用函数每次执行时都可能对应不同case）。              //
//因为以下都是通用函数接口，即一个接口支持所有effect／调用case，但是参数就比较多，给调用方带来理解难度，因此上面已经             //
//对每种支持的effect和常用调用case单独写个简易的接口（而在那些简易接口里面调下面这些通用接口，对调用方尽量屏蔽以下通用但复杂的接口）//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//必须在glcontext上下文中！
//todo: 加注释，说清楚哪些effect可加参数
int SetParamsForEffect(AliEffectType effectType, EffectParams effectParams);

//必须在glcontext上下文中！
//改变动态贴图效果的资源和位置
//todo: 加注释，说清楚哪些effect可调这个接口，说清楚每个参数的含义
int UpdateUsrImgResInfoForEffect(
        AliEffectType effectType,
        bool bIfUpdateResourceRawData, ImgRawData *pImgResourceRawDataArray[MAX_COLOR_TABLE_NUM],
        bool bIfUpdateResourcPosition,
        ResourceVertexPosition *pResourceVertexPositionArray_InPixel[MAX_COLOR_TABLE_NUM],
        int iResourceNum);


//必须在glcontext上下文中！
bool FrameProcess(
        bool bIfNeedUpdateBackYuvImg,//true

        int iInputType,  //TEXTURE_ID_AS_INPUT_TYPE 或 USR_ALLOC_TEXTURE_ID_AS_INPUT_TYPE 或 RAW_DATA_AS_INPUT_TYPE
        GpuImgResourceInfo *pInputOesTexInfo, // 如果上面是TEXTURE_ID_AS_INPUT_TYPE 或 USR_ALLOC_TEXTURE_ID_AS_INPUT_TYPE才需要填，否则为NULL
        ImgRawData *pInputRawData, // 如果上面是RAW_DATA_AS_INPUT_TYPE才需要填，否则为NULL

        int *pFaceRect, float *pFaceLandmark,//直接把人脸算法的输出赋值到这里

        int iOutputType, // TEXTURE_ID_AS_OUTPUT_TYPE 或  USR_FBO_ID_AS_OUTPUT_TYPE 或 RAW_DATA_AS_OUTPUT_TYPE
        GpuImgResourceInfo *pOutputIdInfo, // 如果上面是TEXTURE_ID_AS_OUTPUT_TYPE 或 USR_FBO_ID_AS_OUTPUT_TYPE 才需要填，否则为NULL
        ImgRawData *pOutputBuffer, // 如果上面是RAW_DATA_AS_OUTPUT_TYPE才需要填，否则为NULL

        bool bIfReadLastFrameRawdataForSpeed, //false

        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY); //false, false, false



//必须在glcontext上下文中！
int TwoFramesMergeIntoOne(
        ImgRawData *pInputRawData0,
        ImgRawData *pInputRawData1,

        int iOutputType, // TEXTURE_ID_AS_OUTPUT_TYPE 或  USR_FBO_ID_AS_OUTPUT_TYPE 或 RAW_DATA_AS_OUTPUT_TYPE
        GpuImgResourceInfo *pOutputIdInfo, // 如果上面是TEXTURE_ID_AS_OUTPUT_TYPE 或 USR_FBO_ID_AS_OUTPUT_TYPE 才需要填，否则为NULL
        ImgRawData *pOutputRawData, // 如果上面是RAW_DATA_AS_OUTPUT_TYPE才需要填，否则为NULL

        bool bIfNeedRotate90, bool bIfNeedFlipX, bool bIfNeedFlipY);


#ifdef __cplusplus
#if __cplusplus
}
#endif
#endif /* __cplusplus */


#endif



