(function () {
'use strict';

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

console.log('isssr:' + window.__isSSR);
var isIOS = self.window.navigator.platform === 'iOS';
var baseMods = ['@ali/rax-pkg-rax/index-es6', '@ali/rax-pkg-rax-link/index-es6', '@ali/rax-pkg-rax-children/index-es6', '@ali/rax-pkg-rax-proptypes/index-es6', '@ali/rax-pkg-rax-set-native-props/index-es6', '@ali/rax-pkg-style-unit/index-es6', '@ali/rax-pkg-rax-find-dom-node/index-es6', '@ali/rax-pkg-universal-env/index-es6', '@ali/rax-pkg-rax-view/index-es6', '@ali/rax-pkg-rax-text/index-es6', '@ali/rax-pkg-rax-image/index-es6', '@ali/rax-pkg-rax-picture/index-es6', '@ali/rax-pkg-rax-scrollview/index-es6', '@ali/rax-pkg-rax-recyclerview/index-es6'];
var Url =
function () {
  function Url() {
    _classCallCheck(this, Url);
    this._params = {};
    this._hash = '';
  }
  _createClass(Url, [{
    key: "parse",
    value: function parse() {
      var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var matchArr;
      var hrefAttr = v.split('?');
      var urlReg = new RegExp('^([a-z0-9-]+:)?' +
      '[/]{2}' +
      '(?:([^@/:?]+)(?::([^@/:]+))?@)?' +
      '([^:/?#]+)' +
      '(?:[:]([0-9]+))?' +
      '([/][^?#]*)?' +
      '(?:[?]([^?#]*))?' +
      '(#[^#]*)?$'
      , 'i');
      matchArr = v.match(urlReg) || hrefAttr[0].match(urlReg);
      if (matchArr) {
        hrefAttr.shift();
        this.protocol = matchArr[1] || '';
        this.username = matchArr[2] || '';
        this.password = matchArr[3] || '';
        this.hostname = this.host = matchArr[4];
        this.port = matchArr[5] || '';
        this.pathname = matchArr[6] || '/';
        this.search = matchArr[7] || hrefAttr.join('?') || '';
        this.hash = matchArr[8] || '';
        this.origin = this.protocol + '//' + this.hostname;
      } else {
        console.error('wrong url scheme');
        throw new Error('parse url error');
      }
      this._url = v;
      return this;
    }
  }, {
    key: "toString",
    value: function toString() {
      var string = this.protocol ? this.protocol + '//' : '//';
      if (this.username) {
        string += this.username;
        if (this.password) {
          string += ':' + this.password;
        }
        string += '@';
      }
      string += this.host ? this.host : '';
      if (this.port && this.port !== '80') {
        string += ':' + this.port;
      }
      if (this.pathname) {
        string += this.pathname;
      }
      if (!string) {
        return this._url;
      }
      if (this.search) {
        string += this.search;
      }
      if (this.hash) {
        string += this.hash;
      }
      return string;
    }
  }, {
    key: "params",
    get: function get() {
      return this._params;
    },
    set: function set(v) {
      if (_typeof(v) === 'object') {
        this._params = v;
      }
    }
  }, {
    key: "search",
    set: function set(v) {
      if (typeof v === 'string') {
        if (v.indexOf('?') === 0) {
          v = v.substr(1);
        }
        var search = v.split('&');
        for (var p in this.params) {
          delete this.params[p];
        }
        for (var i = 0; i < search.length; i++) {
          var pair = search[i].split('=');
          if (pair[0]) {
            try {
              this.params[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1] || '');
            } catch (e) {
              this.params[pair[0]] = pair[1] || '';
            }
          }
        }
      }
    },
    get: function get() {
      var search = [];
      for (var p in this.params) {
        if (this.params[p]) {
          try {
            search.push(encodeURIComponent(p) + '=' + encodeURIComponent(this.params[p]));
          } catch (e) {
          }
        } else {
          try {
            search.push(encodeURIComponent(p));
          } catch (e) {
          }
        }
      }
      if (search.length) {
        return '?' + search.join('&');
      } else {
        return '';
      }
    }
  }, {
    key: "hash",
    set: function set(v) {
      if (typeof v === 'string') {
        if (v && v.indexOf('#') < 0) {
          v = '#' + v;
        }
        this._hash = v || '';
      }
    },
    get: function get() {
      return this._hash;
    }
  }]);
  return Url;
}();
var documentUrl;
if (typeof bundleUrl === 'string') {
  documentUrl = new Url().parse(bundleUrl);
  documentUrl.href = bundleUrl;
  documentUrl._href = bundleUrl;
  documentUrl.reload = function () {};
  documentUrl.replace = function () {};
  documentUrl.assign = function () {};
  document.origin = documentUrl.origin;
} else {
  var https_appx = 'https://native/ssr';
  documentUrl = {
    _href: https_appx,
    href: https_appx,
    search: '',
    hash: '',
    host: 'nsr',
    hostname: 'nsr',
    origin: https_appx,
    pathname: '/',
    port: '',
    protocol: 'https:',
    reload: function reload() {},
    replace: function replace() {},
    assign: function assign() {}
  };
  document.origin = https_appx;
}
self.location = window.location = document.location = documentUrl;
function getComboResUrl(url) {
  return isIOS ? url.replace(/-es6\.js/g, '.js') : url;
}
function getModNameByCdnPath(path) {
  var name = path;
  var suffix = 'index-es6';
  var VERSION_REG = /\d+\.\d+\.\d+/;
  if (path.startsWith('code/npm/')) {
    name = name.replace(/^code\/npm\//ig, '');
  }
  var pathArr = name.split('/');
  var nameArr = [];
  for (var i = 0, len = pathArr.length; i < len; i++) {
    if (pathArr[i].match(VERSION_REG)) {
      break;
    }
    nameArr.push(pathArr[i]);
  }
  if (nameArr.length > 0) {
    name = nameArr[0] === '@ali' ? nameArr.join('/') : '@ali/' + nameArr.join('-');
    name = name + '/' + suffix;
  }
  return name;
}
function filterExistRes(comboResUrl) {
  var index = comboResUrl.indexOf('??');
  if (index >= 0) {
    var baseUrl = comboResUrl.substring(0, index);
    var _parse = new Url().parse(baseUrl),
        hostname = _parse.hostname,
        pathname = _parse.pathname;
    var filterRes = comboResUrl.substring(index + 2).split(',').filter(function (v) {
      var name = getModNameByCdnPath(v);
      return baseMods.indexOf(name) < 0;
    });
    return getComboResUrl('//' + hostname + pathname + '??' + filterRes.join(','));
  }
  return getComboResUrl(comboResUrl);
}
var appClientPackageName = isIOS ? '@ali/rox-rax-app-client/index' : '@ali/rox-rax-app-client/index-es6';
require(appClientPackageName, function (client) {
  if (client["default"]) {
    client = client["default"];
  }

  __get_page_data__(function (data, pageUrl) {
    if (!data) {
      console.log('pha page-render.js get data error');
      __nsr_error_callback__('data', 'get data error');
      return;
    }
    console.log('pha page-render.js get data end: ');
    try {
      data = JSON.parse(data);
    } catch (e) {
      __nsr_error_callback__('data', 'data parse error');
      data = {};
      return;
    }
    console.log('pha page-render.js data is: ' + data);
    if (data.data && data.data.resultValue) {
      data = data.data.resultValue;
      if (data.seedComboUris && data.seedComboUris.length > 0) {
        var item = data.seedComboUris[0];
        if (item.type === 'js') {
          var comboUri = filterExistRes(item.uri);
          console.log('pha page-render.js get modsjs start');
          __get_page_modules_js__(comboUri, function (modsjs) {
            console.log('get modsjs end');
            if (modsjs) {
              try {
                console.log('pha page-render.js exec modjs start');
                var modFunc = new Function('with(this){(function(){"use strict";\n' + modsjs + '\n}).call(this)}');
                modFunc.call(self);
                console.log('pha page-render.js exec modjs end');
              } catch (e) {
                console.log(e);
                __nsr_error_callback__('modsjs', 'execute mods js error');
                return;
              }
              try {
                console.log('pha page-render.js render start');
                client(data)["catch"](function (error) {
                  console.log("pha page-render.js client error: ".concat(error, " ").concat(error.message));
                  __nsr_error_callback__('render', 'render error');
                });
                console.log('pha page-render.js render end');
              } catch (e) {
                console.log('pha page-render.js error: ', e);
                __nsr_error_callback__('render', 'render error');
              }
            } else {
              console.log('pha page-render.js no modsjs');
              __nsr_error_callback__('modsjs', 'get mods js error');
            }
          });
        }
      }
    } else {
      __nsr_error_callback__('data', 'data struct error');
    }
  });
});

}());