function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

var __nativeLog__ = self.__nativeLog__;
var __nativeLogError__ = self.__nativeLogError__;
var __nativeLogWarn__ = self.__nativeLogWarn__;
var __nativeCreateTimer__ = self.__nativeCreateTimer__;
var __nativeDeleteTimer__ = self.__nativeDeleteTimer__;
var __pha_env__ = (typeof PHAEnvironment === "undefined" ? "undefined" : _typeof(PHAEnvironment)) === 'object' && PHAEnvironment || {};
function nop() {}
function returnEmptyArray() {
  return [];
}
function _log() {
  try {
    var msg = '';
    for (var i = 0; i < arguments.length; i++) {
      var value = arguments[i];
      if (i > 0) msg += ' ';
      if (value instanceof Error) {
        msg += value.message + '\n' + value.stack;
      } else {
        msg += _typeof(value) == 'object' ? JSON.stringify(value) : value;
      }
    }
//    __nativeLog__(msg);
  } catch (err) {
//    __nativeLog__('err: ', err);
  }
}
var isIOS = __pha_env__.osName === 'iOS';
var log = isIOS ? __nativeLog__ : _log;
function createTimer(args, repeat) {
  var fn = args[0];
  if (typeof fn === 'string') {
    fn = new Function(fn);
  } else if (typeof fn !== 'function') {
    return -1;
  }
  var delay = args[1] | 0;
  var aArgs = Array.prototype.slice.call(args, 2);
  return __nativeCreateTimer__(function () {
    try {
      fn.apply(self, aArgs);
    } catch (err) {
      console.error("###\n".concat(err.stack, "\n###"));
      if (typeof self.onerror === 'function') {
        self.onerror(err);
      }
    }
  }, delay, repeat);
}
self.__nativeLog__ = null;
self.__nativeLogError__ = null;
self.__nativeLogWarn__ = null;
self.__nativeCreateTimer__ = null;
self.__nativeDeleteTimer__ = null;
self.__nativeFlushQueue__ = null;
self.setTimeout = function () {
  return createTimer(arguments, false);
};
self.setInterval = function () {
  return createTimer(arguments, true);
};
self.clearTimeout = self.clearInterval = function (id) {
  __nativeDeleteTimer__(id | 0);
};
self.close = nop;
self.postMessage = nop;
self.performance = {
  clearMarks: nop,
  clearMeasures: nop,
  clearResourceTimings: nop,
  getEntries: returnEmptyArray,
  getEntriesByName: returnEmptyArray,
  getEntriesByType: returnEmptyArray,
  setResourceTimingBufferSize: nop,
  mark: nop,
  measure: nop,
  now: function now() {
    return Date.now();
  },
  toJSON: function toJSON() {
    return {};
  }
};
self.console = {
  log: log,
  info: log,
  debug: log,
  warn: isIOS ? __nativeLogWarn__ : log,
  error: isIOS ? __nativeLogError__ : log,
  exception: log,
  clear: nop,
  count: nop,
  countReset: nop,
  dir: nop,
  dirxml: nop,
  group: nop,
  groupCollapsed: nop,
  groupEnd: nop,
  profile: nop,
  profileEnd: nop,
  table: nop,
  time: nop,
  timeEnd: nop,
  timeLog: nop,
  timeStamp: nop,
  trace: nop,
  assert: function assert() {
    if (arguments[0]) return;
    console.warn('Assertion failed:', Array.prototype.slice.call(arguments).slice(1));
  }
};
var sendMessageQueue = [];
var https_appx = 'https://native/ssr';
var document = {
  documentElement: {
    offsetWidth: __pha_env__.deviceWidth,
    offsetHeight: __pha_env__.deviceHeight,
    clientWidth: __pha_env__.deviceWidth,
    clientHeight: __pha_env__.deviceHeight
  },
  createElement: function createElement() {
    return {};
  },
  addEventListener: nop,
  removeEventListener: nop,
  trigger: nop,
  sendMessageQueue: sendMessageQueue,
  createEvent: nop,
  dispatchEvent: nop,
  title: '',
  origin: https_appx,
  body: {
    style: {
      backgroundColor: ''
    }
  }
};
self.addEventListener = function () {};
self.removeEventListener = function () {};
self.history = {
  length: 1
};
self.origin = document.origin;
self.document = document;
self.window = self;
self.window = Object.assign(self.window, {
  __isSSR: true,
  __supportsES6: !isIOS,
  devicePixelRatio: __pha_env__.scale,
  navigator: {
    product: 'ssr',
    platform: __pha_env__.platform,
    appName: __pha_env__.appName,
    appVersion: __pha_env__.appVersion,
    userAgent: "PHA/".concat(__pha_env__.phaVersion, " ").concat(__pha_env__.platform, "/").concat(__pha_env__.osVersion, " (").concat(__pha_env__.deviceModel, ") ").concat(__pha_env__.appName, "/").concat(__pha_env__.appVersion)
  },
  screen: {
    width: __pha_env__.deviceWidth,
    height: __pha_env__.deviceHeight,
    availWidth: __pha_env__.deviceWidth,
    availHeight: __pha_env__.deviceHeight,
    colorDepth: 24,
    pixelDepth: 24
  },
  localStorage: {
    removeItem: nop,
    setItem: nop,
    getItem: nop,
    clear: nop,
    key: nop
  },
  setImmediate: nop,
  clearImmediate: nop,
  fetch: nop
});
function index () {}
